%Copyright (C) 2005  Tharreau-Taklidi
%This program is free software; you can redistribute it and/or
%modify it under the terms of the GNU General Public License
%as published by the Free Software Foundation; either version 2
%of the License, or (at your option) any later version.

%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.

function [ok,xmin,xmax,ymin,ymax] = critere(imgc, mat_label, label, seuil)

% Recherche de la zone de l'image a evalu�
[X Y] = find(mat_label == label);

if(sum(sum(mat_label == label)) ~= 0)

% Calcule des bornes
xmin = min(X);
xmax = max(X);
ymin = min(Y);
ymax = max(Y);

% Extraction de la sous partie de l'image
M = imgc(xmin:xmax , ymin:ymax,:);

% R�up�ation des valeur min et max de chaque couleur(RGB) de l'image
valRedMax = double(max(max(M(:,:,1))));
valRedMin = double(min(min(M(:,:,1))));
valGreenMax = double(max(max(M(:,:,2))));
valGreenMin = double(min(min(M(:,:,2))));
valBlueMax = double(max(max(M(:,:,3))));
valBlueMin = double(min(min(M(:,:,3))));

% Calcul du critere
ok = ((1/(valRedMax - valRedMin + valGreenMax - valGreenMin + valBlueMax - valBlueMin + 1)) > seuil);
else 
    ok = 0;
    % les valeur suivantes sont betement mise a 0 mais ne serviront pas ds la suite du prog (permet d'�iter d'avoir des warning)
    xmin = 0;
    xmax = 0;
    ymin = 0;
    ymax = 0;
end