%
% Equalizacao de histograma
%
% Moacir Ponti Jr (ICMC/USP) 2012-1
% 
function B = equalize_histogram(A)

    % calcula histograma da imagem (h)
    [h,t] = imhist(double(A));

    % calcula histograma acumulado
    ha(1) = h(1);
    for i=2:size(h,2)
	ha(i) = ha(i-1)+h(i);
    end

    % recupera o tamanho da imagem
    [N,M] = size(A);

    % cria imagem de saida
    B = zeros(N,M);

    % equaliza o histograma para cada valor de intensidade
    for i=0:255
	B(A==i) = round((255/(N*M))*ha(i+1));
    end